Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 128)
@@ -698,308 +606,157 @@
 
     {
-      name_component = _name+"_glue";
+      src = _name+"_glue";
      
-      log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),name_component.c_str());  
+      log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),src.c_str());  
    
-#ifdef POSITION
-      _component->interface_map (name_component,"",
-				 _name         ,"");
-#endif
-    
-      _component->port_map(name_component,"in_CLOCK" , _name, "in_CLOCK" );
-      _component->port_map(name_component,"in_NRESET", _name, "in_NRESET");
-//       _component->port_map(name_component,"out_CONST_0",_name,"out_CONST_0");
-//       _component->port_map(name_component,"out_CONST_1",_name,"out_CONST_1");
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"",
+                                     dest,"");
+#endif
+          PORT_MAP(_component,src , "in_CLOCK" ,dest, "in_CLOCK");
+          PORT_MAP(_component,src , "in_NRESET",dest, "in_NRESET");
+        }
 
       for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
 	{
-	  _component->port_map(name_component,
-			       "in_GPR_READ_"+toString(j)+"_VAL",
-			       _name, 
-			       "in_GPR_READ_"+toString(j)+"_VAL");
-	  _component->port_map(name_component,
-			       "out_GPR_READ_"+toString(j)+"_ACK",
-			       _name,
-			       "out_GPR_READ_"+toString(j)+"_ACK"           );
+          dest = _name;
+              
+#ifdef POSITION
+          _component->interface_map (src ,"gpr_read_"+toString(j),
+                                     dest,"gpr_read_"+toString(j));
+#endif
+
+          PORT_MAP(_component,src , "in_GPR_READ_"+toString(j)+"_VAL",
+                              dest, "in_GPR_READ_"+toString(j)+"_VAL");
+          PORT_MAP(_component,src ,"out_GPR_READ_"+toString(j)+"_ACK",
+                              dest,"out_GPR_READ_"+toString(j)+"_ACK");
 	  if (_param->_have_port_ooo_engine_id == true)
-	    _component->port_map(name_component,
-				 "in_GPR_READ_"+toString(j)+"_OOO_ENGINE_ID" , 
-				 _name,
-				 "in_GPR_READ_"+toString(j)+"_OOO_ENGINE_ID");
-	  _component->port_map(name_component,
-			       "out_GPR_READ_"+toString(j)+"_DATA"          , 
-			       _name,
-			       "out_GPR_READ_"+toString(j)+"_DATA");
-	  _component->port_map(name_component,
-			       "out_GPR_READ_"+toString(j)+"_DATA_VAL"      , 
-			       _name,
-			       "out_GPR_READ_"+toString(j)+"_DATA_VAL");
-
-	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-	    {
-	      _component->port_map(name_component ,
-				   "out_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL",
-				   _name+"_gpr_"+toString(i),
-				   "in_READ_"+toString(j)+"_VAL"  );
-	      _component->port_map(name_component,
-				   "in_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK"  ,
-				   _name+"_gpr_"+toString(i),
-				   "out_READ_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "in_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_DATA" ,
-				   _name+"_gpr_"+toString(i),
-				   "out_READ_"+toString(j)+"_DATA");
-	      _component->port_map(name_component,
-				   "out_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_VAL"        ,
-				   _name+"_gpr_status_"+toString(i),
-				   "in_READ_"+toString(j)+"_VAL" );
-	      _component->port_map(name_component,
-				   "in_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" ,
-				   _name+"_gpr_status_"+toString(i),
-				   "out_READ_"+toString(j)+"_ACK");
-	      _component->port_map(name_component,
-				   "in_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_DATA_VAL"   ,
-				   _name+"_gpr_status_"+toString(i),
-				   "out_READ_"+toString(j)+"_DATA");
-	    }
+          PORT_MAP(_component,src , "in_GPR_READ_"+toString(j)+"_OOO_ENGINE_ID",
+                              dest, "in_GPR_READ_"+toString(j)+"_OOO_ENGINE_ID");
+          PORT_MAP(_component,src ,"out_GPR_READ_"+toString(j)+"_DATA",
+                              dest,"out_GPR_READ_"+toString(j)+"_DATA");
+          PORT_MAP(_component,src ,"out_GPR_READ_"+toString(j)+"_DATA_VAL",
+                              dest,"out_GPR_READ_"+toString(j)+"_DATA_VAL");
+
+          // out_GPR_READ_REGISTERFILE_VAL   - gpr. in_READ_VAL
+          //  in_GPR_READ_REGISTERFILE_ACK   - gpr.out_READ_ACK
+          //  in_GPR_READ_REGISTERFILE_DATA  - gpr.out_READ_DATA
+          
+          // out_GPR_READ_STATUS_VAL         - gpr. in_READ_VAL
+          //  in_GPR_READ_STATUS_ACK         - gpr.out_READ_ACK
+          //  in_GPR_READ_STATUS_DATA_VAL    - gpr.out_READ_DATA
 	}
 
       for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
 	{
-	  _component->port_map(name_component,
-			       "in_GPR_WRITE_"+toString(j)+"_VAL",
-			       _name, 
-			       "in_GPR_WRITE_"+toString(j)+"_VAL"           );
-	  _component->port_map(name_component,
-			       "out_GPR_WRITE_"+toString(j)+"_ACK", 
-			       _name,
-			       "out_GPR_WRITE_"+toString(j)+"_ACK"           );
+          dest = _name;
+
+#ifdef POSITION
+          _component->interface_map (src ,"gpr_write_"+toString(j),
+                                     dest,"gpr_write_"+toString(j));
+#endif
+
+          PORT_MAP(_component,src , "in_GPR_WRITE_"+toString(j)+"_VAL",
+                              dest, "in_GPR_WRITE_"+toString(j)+"_VAL");
+          PORT_MAP(_component,src ,"out_GPR_WRITE_"+toString(j)+"_ACK",
+                              dest,"out_GPR_WRITE_"+toString(j)+"_ACK");
 	  if (_param->_have_port_ooo_engine_id == true)
-	    _component->port_map(name_component,
-				 "in_GPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID", 
-				 _name,
-				 "in_GPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID" );
-	  
-	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+          PORT_MAP(_component,src , "in_GPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID",
+                              dest, "in_GPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID");
+
+          // out_GPR_WRITE_REGISTERFILE_VAL - gpr. in_WRITE_VAL
+          //  in_GPR_WRITE_REGISTERFILE_ACK - gpr.out_WRITE_ACK
+          // out_GPR_WRITE_STATUS_VAL       - gpr. in_WRITE_VAL
+          //  in_GPR_WRITE_STATUS_ACK       - gpr.out_WRITE_ACK
+          // out_GPR_WRITE_STATUS_DATA      - gpr. in_WRITE_DATA
+	}
+
+      for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+	{
+          dest = _name;
+              
+#ifdef POSITION
+          _component->interface_map (src ,"spr_read_"+toString(j),
+                                     dest,"spr_read_"+toString(j));
+#endif
+
+          PORT_MAP(_component,src , "in_SPR_READ_"+toString(j)+"_VAL",
+                              dest, "in_SPR_READ_"+toString(j)+"_VAL");
+          PORT_MAP(_component,src ,"out_SPR_READ_"+toString(j)+"_ACK",
+                              dest,"out_SPR_READ_"+toString(j)+"_ACK");
+	  if (_param->_have_port_ooo_engine_id == true)
+          PORT_MAP(_component,src , "in_SPR_READ_"+toString(j)+"_OOO_ENGINE_ID",
+                              dest, "in_SPR_READ_"+toString(j)+"_OOO_ENGINE_ID");
+          PORT_MAP(_component,src ,"out_SPR_READ_"+toString(j)+"_DATA",
+                              dest,"out_SPR_READ_"+toString(j)+"_DATA");
+          PORT_MAP(_component,src ,"out_SPR_READ_"+toString(j)+"_DATA_VAL",
+                              dest,"out_SPR_READ_"+toString(j)+"_DATA_VAL");
+
+          // out_SPR_READ_REGISTERFILE_VAL   - spr. in_READ_VAL
+          //  in_SPR_READ_REGISTERFILE_ACK   - spr.out_READ_ACK
+          //  in_SPR_READ_REGISTERFILE_DATA  - spr.out_READ_DATA
+          
+          // out_SPR_READ_STATUS_VAL         - spr. in_READ_VAL
+          //  in_SPR_READ_STATUS_ACK         - spr.out_READ_ACK
+          //  in_SPR_READ_STATUS_DATA_VAL    - spr.out_READ_DATA
+	}
+
+      for (uint32_t j=0; j<_param->_nb_spr_write; j++)
+	{
+          dest = _name;
+
+#ifdef POSITION
+          _component->interface_map (src ,"spr_write_"+toString(j),
+                                     dest,"spr_write_"+toString(j));
+#endif
+
+          PORT_MAP(_component,src , "in_SPR_WRITE_"+toString(j)+"_VAL",
+                              dest, "in_SPR_WRITE_"+toString(j)+"_VAL");
+          PORT_MAP(_component,src ,"out_SPR_WRITE_"+toString(j)+"_ACK",
+                              dest,"out_SPR_WRITE_"+toString(j)+"_ACK");
+	  if (_param->_have_port_ooo_engine_id == true)
+          PORT_MAP(_component,src , "in_SPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID",
+                              dest, "in_SPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID");
+
+          // out_SPR_WRITE_REGISTERFILE_VAL - spr. in_WRITE_VAL
+          //  in_SPR_WRITE_REGISTERFILE_ACK - spr.out_WRITE_ACK
+          // out_SPR_WRITE_STATUS_VAL       - spr. in_WRITE_VAL
+          //  in_SPR_WRITE_STATUS_ACK       - spr.out_WRITE_ACK
+          // out_SPR_WRITE_STATUS_DATA      - spr. in_WRITE_DATA
+	}
+
+      for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	{
+	  uint32_t x     =_param->_nb_inst_insert_rob [i];
+
+	  for (uint32_t j=0; j<x; j++)
 	    {
-	      _component->port_map(name_component,
-				   "out_GPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL"  ,
-				   _name+"_gpr_"+toString(i),
-				   "in_WRITE_"+toString(j)+"_VAL" );
-	      _component->port_map(name_component,
-				   "in_GPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK"  ,
-				   _name+"_gpr_"+toString(i),
-				   "out_WRITE_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "out_GPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_VAL"        ,
-				   _name+"_gpr_status_"+toString(i),
-				   "in_WRITE_"+toString(j)+"_VAL" );
-	      _component->port_map(name_component,
-				   "in_GPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_ACK"        ,
-				   _name+"_gpr_status_"+toString(i),
-				   "out_WRITE_"+toString(j)+"_ACK" );
+              dest = _name;
+
+#ifdef POSITION
+              _component->interface_map (src ,"insert_rob_"+toString(i)+"_"+toString(j),
+                                         dest,"insert_rob_"+toString(i)+"_"+toString(j));
+#endif
+
+	      PORT_MAP(_component,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL",
+                                  dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL");
+	      PORT_MAP(_component,src ,"out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK",
+                                  dest,"out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK");
+	      PORT_MAP(_component,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE",
+                                  dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE");
+	      PORT_MAP(_component,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE",
+                                  dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE");
+              
+              // out_INSERT_ROB_GPR_STATUS_VAL - gpr_status.  in_WRITE_VAL
+              //  in_INSERT_ROB_GPR_STATUS_ACK - gpr_status. out_WRITE_ACK
+              // out_INSERT_ROB_GPR_STATUS_DATA- gpr_status.  in_WRITE_DATA
+              // out_INSERT_ROB_SPR_STATUS_VAL - spr_status.  in_WRITE_VAL
+              //  in_INSERT_ROB_SPR_STATUS_ACK - spr_status. out_WRITE_ACK
+              //  in_INSERT_ROB_SPR_STATUS_DATA- spr_status. out_WRITE_DATA
 	    }
 	}
       
-      for (uint32_t j=0; j<_param->_nb_spr_read; j++)
-	{
-	  _component->port_map(name_component,
-			       "in_SPR_READ_"+toString(j)+"_VAL",
-			       _name, 
-			       "in_SPR_READ_"+toString(j)+"_VAL");
-	  _component->port_map(name_component,
-			       "out_SPR_READ_"+toString(j)+"_ACK",
-			       _name,
-			       "out_SPR_READ_"+toString(j)+"_ACK"           );
-	  if (_param->_have_port_ooo_engine_id == true)
-	    _component->port_map(name_component,
-				 "in_SPR_READ_"+toString(j)+"_OOO_ENGINE_ID" , 
-				 _name,
-				 "in_SPR_READ_"+toString(j)+"_OOO_ENGINE_ID");
-	  _component->port_map(name_component,
-			       "out_SPR_READ_"+toString(j)+"_DATA"          , 
-			       _name,
-			       "out_SPR_READ_"+toString(j)+"_DATA");
-	  _component->port_map(name_component,
-			       "out_SPR_READ_"+toString(j)+"_DATA_VAL"      , 
-			       _name,
-			       "out_SPR_READ_"+toString(j)+"_DATA_VAL");
-
-	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-	    {
-	      _component->port_map(name_component ,
-				   "out_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL",
-				   _name+"_spr_"+toString(i),
-				   "in_READ_"+toString(j)+"_VAL"  );
-	      _component->port_map(name_component,
-				   "in_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK"  ,
-				   _name+"_spr_"+toString(i),
-				   "out_READ_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "in_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_DATA" ,
-				   _name+"_spr_"+toString(i),
-				   "out_READ_"+toString(j)+"_DATA");
-	      _component->port_map(name_component,
-				   "out_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_VAL"        ,
-				   _name+"_spr_status_"+toString(i),
-				   "in_READ_"+toString(j)+"_VAL" );
-	      _component->port_map(name_component,
-				   "in_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" ,
-				   _name+"_spr_status_"+toString(i),
-				   "out_READ_"+toString(j)+"_ACK");
-	      _component->port_map(name_component,
-				   "in_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_DATA_VAL"   ,
-				   _name+"_spr_status_"+toString(i),
-				   "out_READ_"+toString(j)+"_DATA");
-	    }
-	}
-
-      for (uint32_t j=0; j<_param->_nb_spr_write; j++)
-	{
-	  _component->port_map(name_component,
-			       "in_SPR_WRITE_"+toString(j)+"_VAL",
-			       _name, 
-			       "in_SPR_WRITE_"+toString(j)+"_VAL"           );
-	  _component->port_map(name_component,
-			       "out_SPR_WRITE_"+toString(j)+"_ACK", 
-			       _name,
-			       "out_SPR_WRITE_"+toString(j)+"_ACK"           );
-	  if (_param->_have_port_ooo_engine_id == true)
-	    _component->port_map(name_component,
-				 "in_SPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID", 
-				 _name,
-				 "in_SPR_WRITE_"+toString(j)+"_OOO_ENGINE_ID" );
-	  
-	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-	    {
-	      _component->port_map(name_component,
-				   "out_SPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL"  ,
-				   _name+"_spr_"+toString(i),
-				   "in_WRITE_"+toString(j)+"_VAL" );
-	      _component->port_map(name_component,
-				   "in_SPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK"  ,
-				   _name+"_spr_"+toString(i),
-				   "out_WRITE_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "out_SPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_VAL"        ,
-				   _name+"_spr_status_"+toString(i),
-				   "in_WRITE_"+toString(j)+"_VAL" );
-	      _component->port_map(name_component,
-				   "in_SPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_ACK"        ,
-				   _name+"_spr_status_"+toString(i),
-				   "out_WRITE_"+toString(j)+"_ACK" );
-	    }
-	}
-
-      for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-	{
-	  uint32_t x     =_param->_nb_inst_insert_rob [i];
-	  uint32_t gpr_j = _param->_nb_gpr_write;
-	  uint32_t spr_j = _param->_nb_spr_write;
-
-	  for (uint32_t j=0; j<x; j++)
-	    {
-	      _component->port_map(name_component,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL",
-				   _name,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL");
-	      _component->port_map(name_component,
-				   "out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK",
-				   _name,
-				   "out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK");
-	      _component->port_map(name_component,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE",
-				   _name,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE");
-	      _component->port_map(name_component,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE",
-				   _name,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE");
-	      _component->port_map(name_component,
-				   "out_INSERT_ROB_GPR_STATUS_"+toString(i)+"_"+toString(j)+"_VAL",
-				   _name+"_gpr_status_"+toString(i),
-				   "in_WRITE_"+toString(gpr_j)+"_VAL");
-	      _component->port_map(name_component,
-				   "in_INSERT_ROB_GPR_STATUS_"+toString(i)+"_"+toString(j)+"_ACK",
-				   _name+"_gpr_status_"+toString(i),
-				   "out_WRITE_"+toString(gpr_j++)+"_ACK");
-	      _component->port_map(name_component,
-				   "out_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_VAL",
-				   _name+"_spr_status_"+toString(i),
-				   "in_WRITE_"+toString(spr_j)+"_VAL");
-	      _component->port_map(name_component,
-				   "in_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_ACK",
-				   _name+"_spr_status_"+toString(i),
-				   "out_WRITE_"+toString(spr_j++)+"_ACK");
-	    }
-	}
-
-//       for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-// 	{
-// 	  uint32_t x     =_param->_nb_inst_retire_rob [i];
-// 	  uint32_t gpr_j = _param->_nb_gpr_write + _param->_nb_inst_insert_rob [i];
-// 	  uint32_t spr_j = _param->_nb_spr_write + _param->_nb_inst_insert_rob [i];
-
-// 	  for (uint32_t j=0; j<x; j++)
-// 	    {
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_VAL",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "out_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_ACK",
-// 				   _name,
-// 				   "out_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_ACK");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RD_OLD_USE",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RD_OLD_USE");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RD_NEW_USE",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RD_NEW_USE");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RE_OLD_USE",
-// 				   _name, 
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RE_OLD_USE");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RE_NEW_USE",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RE_NEW_USE");
-	    
-// 	      _component->port_map(name_component,
-// 				   "out_RETIRE_ROB_GPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_VAL",
-// 				   _name+"_gpr_status_"+toString(i),
-// 				   "in_WRITE_"+toString(gpr_j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_GPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_ACK",
-// 				   _name+"_gpr_status_"+toString(i),
-// 				   "out_WRITE_"+toString(gpr_j++)+"_ACK");
-// 	      _component->port_map(name_component,
-// 				   "out_RETIRE_ROB_GPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_VAL",
-// 				   _name+"_gpr_status_"+toString(i),
-// 				   "in_WRITE_"+toString(gpr_j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_GPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_ACK",
-// 				   _name+"_gpr_status_"+toString(i),
-// 				   "out_WRITE_"+toString(gpr_j++)+"_ACK");
-// 	      _component->port_map(name_component,
-// 				   "out_RETIRE_ROB_SPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_VAL",
-// 				   _name+"_spr_status_"+toString(i),
-// 				   "in_WRITE_"+toString(spr_j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_SPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_ACK",
-// 				   _name+"_spr_status_"+toString(i),
-// 				   "out_WRITE_"+toString(spr_j++)+"_ACK");
-// 	      _component->port_map(name_component,
-// 				   "out_RETIRE_ROB_SPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_VAL",
-// 				   _name+"_spr_status_"+toString(i),
-// 				   "in_WRITE_"+toString(spr_j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "in_RETIRE_ROB_SPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_ACK",
-// 				   _name+"_spr_status_"+toString(i),
-// 				   "out_WRITE_"+toString(spr_j++)+"_ACK");
-// 	    }
-// 	}
     }// glue
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_deallocation.cpp	(revision 128)
@@ -74,5 +74,11 @@
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-
+    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+      {
+    delete    component_gpr        [i];
+    delete    component_gpr_status [i];
+    delete    component_spr        [i];
+    delete    component_spr_status [i];
+      }
     delete [] component_gpr       ;
     delete [] component_gpr_status;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 128)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h"
+#include "Behavioural/include/Allocation.h"
 
 #define NB_PARAMS 18
@@ -309,4 +310,9 @@
   morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void) = &(morpheo::behavioural::custom::default_get_custom_information);
 
+  bool * num_thread_valid;
+  ALLOC1(num_thread_valid              ,bool, nb_thread);
+  for (uint32_t i=0; i<nb_thread; ++i)
+    num_thread_valid [i] = true;
+
   try 
     {
@@ -367,8 +373,11 @@
          is_load_store_unit                            , //[nb_execute_unit]
          translate_num_execute_unit                    , //[nb_execute_unit]
+         num_thread_valid                              , //[nb_thread]
          true // is_toplevel
          );
       
       test (name,param);
+
+      delete param;
     }
   catch (morpheo::ErrorMorpheo & error)
@@ -383,4 +392,62 @@
     }
 
+  for (uint32_t i=0; i< nb_functionnal_unit; i++)
+    {
+  for (uint32_t j=0; j< MAX_TYPE; j++)
+  delete [] timing [i][j];
+  delete [] timing [i];
+    }
+  delete [] timing;
+
+  DELETE1(translate_num_execute_unit    ,_nb_execute_unit);
+  DELETE1(is_load_store_unit            ,_nb_execute_unit);
+
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+  delete    read_unit_to_execution_unit_table_thread [i];
+  delete [] read_unit_to_execution_unit_table_thread;
+
+  for (uint32_t i=0; i<nb_read_unit; i++)
+    {
+  for (uint32_t j=0; j<nb_execute_unit; j++)
+  delete [] read_unit_to_execution_unit_table_routing [i][j];
+  delete [] read_unit_to_execution_unit_table_routing [i];
+   }
+  delete [] read_unit_to_execution_unit_table_routing;
+
+  for (uint32_t i=0; i<nb_write_unit; i++)
+  delete    execution_unit_to_write_unit_table_thread [i];
+  delete [] execution_unit_to_write_unit_table_thread;
+
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+    {
+      uint32_t nb_execute_unit_port = (i<nb_load_store_unit)?nb_inst_memory[i]:nb_inst_functionnal_unit[i-nb_load_store_unit];
+  for (uint32_t j=0; j<nb_execute_unit_port; j++)
+  delete [] execution_unit_to_write_unit_table_routing [i][j];
+  delete [] execution_unit_to_write_unit_table_routing [i];
+   }
+  delete [] execution_unit_to_write_unit_table_routing;
+
+  DELETE1(nb_inst_retire_rob            ,_nb_ooo_engine);
+  DELETE1(nb_inst_insert_rob            ,_nb_ooo_engine);
+  DELETE1(nb_special_register           ,_nb_ooo_engine);
+  DELETE1(nb_general_register           ,_nb_ooo_engine);
+  DELETE1(write_queue_scheme            ,_nb_write_unit);
+  DELETE1(nb_bypass_write               ,_nb_write_unit);
+  DELETE1(size_execute_queue            ,_nb_write_unit);
+  DELETE1(size_write_queue              ,_nb_write_unit);
+  DELETE1(nb_inst_memory                ,_nb_load_store_unit);
+  DELETE1(nb_cache_port                 ,_nb_load_store_unit);
+  DELETE1(nb_bypass_memory              ,_nb_load_store_unit);
+  DELETE1(speculative_load              ,_nb_load_store_unit);
+  DELETE1(nb_port_check                 ,_nb_load_store_unit);
+  DELETE1(size_speculative_access_queue ,_nb_load_store_unit);
+  DELETE1(size_load_queue               ,_nb_load_store_unit);
+  DELETE1(size_store_queue              ,_nb_load_store_unit);
+  DELETE1(nb_inst_functionnal_unit      ,_nb_functionnal_unit);
+  DELETE1(nb_inst_retire                ,_nb_read_unit);
+  DELETE1(size_reservation_station      ,_nb_read_unit);
+  DELETE1(size_read_queue               ,_nb_read_unit);
+  DELETE1(num_thread_valid              , nb_thread);
+
   return (EXIT_SUCCESS);
 }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp	(revision 128)
@@ -50,4 +50,69 @@
   sc_clock              *  in_CLOCK  = new sc_clock ("clock", 1.0, 0.5);	 
   sc_signal<Tcontrol_t> *  in_NRESET = new sc_signal<Tcontrol_t> ("NRESET");
+
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_VAL                  ;
+  sc_signal<Tcontrol_t        >  ** out_EXECUTE_LOOP_IN_ACK                  ;
+  sc_signal<Tcontext_t        >  **  in_EXECUTE_LOOP_IN_CONTEXT_ID           ;
+  sc_signal<Tcontext_t        >  **  in_EXECUTE_LOOP_IN_FRONT_END_ID         ;
+  sc_signal<Tcontext_t        >  **  in_EXECUTE_LOOP_IN_OOO_ENGINE_ID        ;
+  sc_signal<Tpacket_t         >  **  in_EXECUTE_LOOP_IN_PACKET_ID            ;
+  sc_signal<Toperation_t      >  **  in_EXECUTE_LOOP_IN_OPERATION            ;
+  sc_signal<Ttype_t           >  **  in_EXECUTE_LOOP_IN_TYPE                 ;
+  sc_signal<Tlsq_ptr_t        >  **  in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE;
+  sc_signal<Tlsq_ptr_t        >  **  in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_HAS_IMMEDIAT         ;
+  sc_signal<Tgeneral_data_t   >  **  in_EXECUTE_LOOP_IN_IMMEDIAT             ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_READ_RA              ;
+  sc_signal<Tgeneral_address_t>  **  in_EXECUTE_LOOP_IN_NUM_REG_RA           ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_READ_RB              ;
+  sc_signal<Tgeneral_address_t>  **  in_EXECUTE_LOOP_IN_NUM_REG_RB           ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_READ_RC              ;
+  sc_signal<Tspecial_address_t>  **  in_EXECUTE_LOOP_IN_NUM_REG_RC           ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_WRITE_RD             ;
+  sc_signal<Tgeneral_address_t>  **  in_EXECUTE_LOOP_IN_NUM_REG_RD           ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_WRITE_RE             ;
+  sc_signal<Tspecial_address_t>  **  in_EXECUTE_LOOP_IN_NUM_REG_RE           ;
+  sc_signal<Tcontrol_t        >  ** out_EXECUTE_LOOP_OUT_VAL                 ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_OUT_ACK                 ;
+  sc_signal<Tcontext_t        >  ** out_EXECUTE_LOOP_OUT_CONTEXT_ID          ;
+  sc_signal<Tcontext_t        >  ** out_EXECUTE_LOOP_OUT_FRONT_END_ID        ;
+  sc_signal<Tcontext_t        >  ** out_EXECUTE_LOOP_OUT_OOO_ENGINE_ID       ;
+  sc_signal<Tpacket_t         >  ** out_EXECUTE_LOOP_OUT_PACKET_ID           ;
+//sc_signal<Toperation_t      >  ** out_EXECUTE_LOOP_OUT_OPERATION           ;
+//sc_signal<Ttype_t           >  ** out_EXECUTE_LOOP_OUT_TYPE                ;
+  sc_signal<Tspecial_data_t   >  ** out_EXECUTE_LOOP_OUT_FLAGS               ;
+  sc_signal<Texception_t      >  ** out_EXECUTE_LOOP_OUT_EXCEPTION           ;
+  sc_signal<Tcontrol_t        >  ** out_EXECUTE_LOOP_OUT_NO_SEQUENCE         ;
+  sc_signal<Taddress_t        >  ** out_EXECUTE_LOOP_OUT_ADDRESS             ;
+  sc_signal<Tgeneral_data_t   >  ** out_EXECUTE_LOOP_OUT_DATA                ;
+  sc_signal<Tcontrol_t        > *** out_DCACHE_REQ_VAL                       ;
+  sc_signal<Tcontrol_t        > ***  in_DCACHE_REQ_ACK                       ;
+  sc_signal<Tcontext_t        > *** out_DCACHE_REQ_CONTEXT_ID                ;
+  sc_signal<Tpacket_t         > *** out_DCACHE_REQ_PACKET_ID                 ;
+  sc_signal<Tdcache_address_t > *** out_DCACHE_REQ_ADDRESS                   ;
+  sc_signal<Tdcache_type_t    > *** out_DCACHE_REQ_TYPE                      ;
+  sc_signal<Tdcache_data_t    > *** out_DCACHE_REQ_WDATA                     ;
+  sc_signal<Tcontrol_t        > ***  in_DCACHE_RSP_VAL                       ;
+  sc_signal<Tcontrol_t        > *** out_DCACHE_RSP_ACK                       ;
+  sc_signal<Tcontext_t        > ***  in_DCACHE_RSP_CONTEXT_ID                ;
+  sc_signal<Tpacket_t         > ***  in_DCACHE_RSP_PACKET_ID                 ;
+  sc_signal<Tdcache_data_t    > ***  in_DCACHE_RSP_RDATA                     ;
+  sc_signal<Tdcache_error_t   > ***  in_DCACHE_RSP_ERROR                     ; 
+  sc_signal<Tcontrol_t        > ***  in_INSERT_ROB_VAL                       ;
+  sc_signal<Tcontrol_t        > *** out_INSERT_ROB_ACK                       ;
+  sc_signal<Tcontrol_t        > ***  in_INSERT_ROB_RD_USE                    ;
+  sc_signal<Tgeneral_address_t> ***  in_INSERT_ROB_RD_NUM_REG                ;
+  sc_signal<Tcontrol_t        > ***  in_INSERT_ROB_RE_USE                    ;
+  sc_signal<Tspecial_address_t> ***  in_INSERT_ROB_RE_NUM_REG                ;
+//sc_signal<Tcontrol_t        > ***  in_RETIRE_ROB_VAL                       ;
+//sc_signal<Tcontrol_t        > *** out_RETIRE_ROB_ACK                       ;
+//sc_signal<Tcontrol_t        > ***  in_RETIRE_ROB_RD_OLD_USE                ; 
+//sc_signal<Tgeneral_address_t> ***  in_RETIRE_ROB_RD_OLD_NUM_REG            ;
+//sc_signal<Tcontrol_t        > ***  in_RETIRE_ROB_RD_NEW_USE                ;
+//sc_signal<Tgeneral_address_t> ***  in_RETIRE_ROB_RD_NEW_NUM_REG            ;
+//sc_signal<Tcontrol_t        > ***  in_RETIRE_ROB_RE_OLD_USE                ; 
+//sc_signal<Tspecial_address_t> ***  in_RETIRE_ROB_RE_OLD_NUM_REG            ;
+//sc_signal<Tcontrol_t        > ***  in_RETIRE_ROB_RE_NEW_USE                ;
+//sc_signal<Tspecial_address_t> ***  in_RETIRE_ROB_RE_NEW_NUM_REG            ;
   
   ALLOC1_SC_SIGNAL( in_EXECUTE_LOOP_IN_VAL                  ," in_EXECUTE_LOOP_IN_VAL                  ",Tcontrol_t        ,_param->_nb_read_unit);
